<?php
/*
VideoWhisper 2 Way Video Chat (for Joomla):

Copyright (C) 2009  VideoWhisper.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 Joomla! 1.5 component Videowhisper_2wvc

 @author VideoWhisper.com
 @package Joomla
 @subpackage Videowhisper_2wvc
 @license GNU/GPL

VideoWhisper 2 Way Video Chat is a premium high definition video communication software designed for instant 1 on 1 online video conferencing. It's a solution for conducting easy to setup face to face meetings without leaving your office or home. It's the easiest and most cost-effective way to meet somebody and discuss one on one.
http://www.videowhisper.com/?p=2+Way+Video+Chat

*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

Header( "Last-Modified: " . gmdate( "D, j M Y H:i:s" ) . " GMT" );
Header( "Expires: " . gmdate( "D, j M Y H:i:s", time() ) . " GMT" );
Header( "cache-Control: no-store, no-cache, must-revalidate" ); // HTTP/1.1
Header( "cache-Control: post-check=0, pre-check=0", FALSE );
Header( "Pragma: no-cache" ); // HTTP/1.0

jimport( 'joomla.application.component.model' );

class Vw2wvcModelFlash extends JModel
{


	function getOutput($task)
	{

	function hasrights($username, $usertype, $owner, $rights)
	{
		if (trim($rights)=="None") return 0;

		$rightslist=explode(",",$rights);
		foreach ($rightslist as $key => $value) $rightslist[$key]=trim($rightslist[$key]);

		if (in_array("All",$rightslist)) return 1;
		if (in_array($username,$rightslist)) return 1;
		if (in_array($usertype,$rightslist)) return 1;
		if (in_array("Admins",$rightslist) && (in_array($usertype, array('Super Administrator', 'Administrator', 'Manager')) || ($username==$owner&&$username))) return 1;
		if (in_array("Members",$rightslist) && $username) return 1;
		return 0;
	}

  	$params = &JComponentHelper::getParams( 'com_videowhisper_2wvc' );
	$rtmp_server=$params->get( 'rtmp' );
	$rtmfp_server=$params->get( 'rtmfp' );
	$serverAMF= $params->get( 'serverAMF' );

	$path="components/com_videowhisper_2wvc/";

	$db =& JFactory::getDBO();

	switch ($task)
	{

	case "login":

	//room cleanups
	$ztime=time();
	$query = "UPDATE #__v2wvc_rooms SET timelastaccess=timecreated where timelastaccess=0";
	$db->setQuery( $query );
  	$db->query();

	$query = "DELETE FROM #__v2wvc_rooms WHERE (( timeexpire > 0) AND ((timeexpire*86400 + timecreated) < $ztime)) OR ((timeout > 0) AND ( ($ztime-timelastaccess) > (timeout * 3600)))";
    $db->setQuery( $query );
  	$db->query();

	//credit reset
	$query = "UPDATE #__v2wvc_rooms SET creditslastreset=$ztime, timeused=0 WHERE (creditsreset > 0) AND (( $ztime - creditslastreset) > (creditsreset *86400))";
	$db->setQuery( $query );
	$db->query();

	$room_name=JRequest::getVar( 'room_name' );

	$sql="SELECT * FROM #__v2wvc_rooms WHERE room='$room_name'";
	$db->setQuery( $sql );
	$room = $db->loadObject();
	if (!$room)
	{
		$message="<a href=\"/\">Room '$room_name' does not exist. Contact administrator!</a>";
		$loggedin=0;
	}
	else
	{
	$owner=$room->owner;

	$user =& JFactory::getUser();
	if (!$user->get('id')) $loggedin=0; else $loggedin=1;
	if (!$loggedin) $message="<a href=\"/\">Please login to your account first (on member frontend)!</a>";
	$username=$user->get('name');
	$usertype=$user->usertype;

	$showcredit=hasrights($username, $usertype, $owner, $room->showcredit);

	if ($room->rtmp) $rtmp_server=$room->rtmp;

	$cam=explode("x", $room->camres);

	$visitor=0;
	if (!$loggedin&&$room->visitors)
	{
		$loggedin=1;
		$username="Guest".rand(0,10000);
		$usertype="Guest";
		$visitor=1;
	}

	//enabled
	if ($room->suspended)
	{
		$message="<a href=\"/\">Room '$room_name' is suspended!</a>";
		$loggedin=0;
		$visitor=0;
	}
	$message=urlencode($message);

  if ($room->credits) $disconnectOnTimeout=1;
  else $disconnectOnTimeout=0;

	$host=$_SERVER['HTTP_HOST'];
	$path=$_SERVER['REQUEST_URI'];
	$lpath=strrchr($path, "/");
	if ($lpath) $path=substr($path,0,-strlen($lpath)+1);
	$apath=urlencode("http://".$host.$path);
}

	return "firstParameter=Fix&server=".urlencode($rtmp_server)."&serverRTMFP=".urlencode($rtmfp_server)."&serverAMF=".$serverAMF."&room=".$room->room."&username=".$username."&visitor=".$visitor."&loggedin=".$loggedin."&msg=$message&webserver=$apath&file_upload=".$allow_fileupload."&file_delete=".$allow_filedelete."&welcome=".urlencode($room->welcome)."&showTimer=1&showCredit=".$showcredit."&disconnectOnTimeout=".$disconnectOnTimeout."&camWidth=".$cam[0]."&camHeight=".$cam[1]."&camFPS=".$room->camfps."&camBandwidth=".$room->bandwidth."&showCamSettings=1&camMaxBandwidth=".$room->maxbandwidth."&loadstatus=1";
	break;

	case "status":
	$room_name = JRequest::getVar( 'r' );
	$session= JRequest::getVar( 's' );
	$username= JRequest::getVar( 'u' );

	$currentTime=JRequest::getVar( 'ct' );
	$lastTime=JRequest::getVar( 'lt' );

	$maximumSessionTime=0;
	$disconnect="";

	$sql="SELECT * FROM #__v2wvc_rooms WHERE room='$room_name'";
	$db->setQuery( $sql );
	$room = $db->loadObject();

	if (!$room)
	{
		$disconnect=urlencode("You were disconnected because room $room_name is missing!");
	}
	else
	{

	if ($room->credits) $maximumSessionTime = $room->credits * 60000;
	if (!$room->timeused) $room->timeused=0;

	//update room stream time
	$deltaTime=$currentTime-$lastTime;
	$time=time();
	$sql = "UPDATE #__v2wvc_rooms SET timeused = timeused + $deltaTime, timelastaccess=$time WHERE room = '$room_name'";
    $db->setQuery( $sql );
  	$db->query();
	//$debug="$deltatime+++$room_name+++$time+++".$db->getErrorMsg."+++".$sql;

	$room->timeused=$room->timeused+$deltaTime;
	}

	return "timeTotal=$maximumSessionTime&timeUsed=".$room->timeused."&lastTime=$currentTime&disconnect=$disconnect&loadstatus=1&debug=$debug";
	break;

	case "chatlog":
	$username=JRequest::getVar( 'u');
	$session=JRequest::getVar( 's');
	$room=JRequest::getVar( 'r');
	$message=JRequest::getVar( 'msg');
	$time=JRequest::getVar( 'msgtime');

	//do not allow uploads to other folders
	if ( strstr($room,"/") || strstr($room,"..") ) exit;

	//create folder to store logs
	$dir=$path."uploads";
	$dir.="/$room";
	if (!file_exists($dir)) mkdir($dir);

	//get daily log name
	$day=date("y-M-j",time());

	$dfile = fopen("uploads/$room/Log$day.html","a");
	fputs($dfile,$message."<BR>");
	fclose($dfile);
	return "loadstatus=1";
	break;
	default:
	return "error=$task-NotSupported";
	break;
	}

    }
}